/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include "logstr.h"
#include "httpd.h"

/*******************************************************************\

Function: httpdt::httpdt

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

httpdt::httpdt(std::istream &_in, std::ostream &_out):
 httpd_baset(_in, _out)
 {
 }

/*******************************************************************\

Function: httpdt::auth_response

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void httpdt::auth_response(const char *realm)
 {
  status_response(401, "authentication required");
  send_server();
  send_connection();

  out << "WWW-Authenticate: Basic realm=\"" << realm << "\"\r\n"
         "\r\n";

  out << "<html>\n"
         "<head>\n"
         "<title>authentication failed</title>\n"
         "<body>\n";

  out << "<h1>authentication failed</h1><P>\n"
         "<p>\n";

  out << "</body>\n"
         "</html>\n";
 }

/*******************************************************************\

Function: httpdt::auth

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void httpdt::auth(const char *realm)
 {
  std::string password;
  basic_auth(username, password);

  if(username=="")
   {
    auth_response(realm);
    throw auth_excpt("no authentication");
   }

  try
   {
    autht auth;
    auth.auth(username, password);
   }

  catch(auth_excpt &e)
   {
    // log it

    logstr << "login of " << username << " failed";
    logstr.log("httpdt::auth");

    auth_response(realm);

    // re-throw it
    throw e;
   }

  // successfull

  logstr << "successfull login of " << username;
  logstr.log("httpdt::auth");

  logstr.log_to_user(username);
 }
