#ifndef DBOX_DBOXFTPD_H
#define DBOX_DBOXFTPD_H

#include <stdio.h>

#include <string>

#include <dblib/os_dep_socket.h>
#include <dbclient/user.h>

/*******************************************************************\

   Class: dbftpdt

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

class dbftpdt
 {
 public:
  dbftpdt(std::istream &_in, std::ostream &_out):
    in(_in), out(_out) { }

  void doit();

 protected:
  std::istream &in;
  std::ostream &out;

  unsigned failcount;
  bool login, has_homedir;
  int data_fd;

  struct sockaddr_in sa;
  struct sockaddr_in port_sa;
  struct sockaddr_in peer;

  bool passive_socket, port_sa_ok;
  std::string cwd, homedir;
  std::string alias;
  std::string homepagedir;
  std::string username;

  usert user;  

  bool dcon_open();
  void dcon_close();

  void mk_filename(const std::string &args, std::string &filename);
  void mk_homedir();

  void dostor(const std::string &args);
  void dolist(bool nlst, const std::string &args);
  void docwd(const std::string &args);
  bool docwd2(const std::string &args);
  void dolist_file(FILE *outfile, bool nlst, const std::string &filename);
  bool douser(const std::string &args);
  bool dopass(const std::string &args);
  bool dopasv();
  bool doport(const std::string &args);
  bool docommand(const std::string &command);
  void domkd(const std::string &args);
  void dodele(const std::string &args);

  std::string get_filename(const std::string &full_path);

  void init();
  void welcome();
  void main_loop();
 };

void dbftpd();

#endif

