/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <libdbox/userdb.h>

#include "alias.h"
#include "userlist.h"

/*******************************************************************\

Function: alias

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void do_alias(std::ostream &out, const std::string &user)
 {
  userpt up(user.c_str());

  if(up.read())
   {
    std::cerr << "failed to read profile of user "
              << user << std::endl;
    return;
   }

  std::string alias;
  up.get("alias", alias);

  if(alias!="")
   {
    out << up.name << "=";
    out << alias;
    out << std::endl;
   }
 }

/*******************************************************************\

Function: alias

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void do_alias(std::ostream &out)
 {
  userlistt userlist;

  get_userlist(userlist);

  for(userlistt::const_iterator it=userlist.begin();
      it!=userlist.end(); it++)
    do_alias(out, *it);
 }

