/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <iostream>

#include <dboxversion.h>
#include <libdboxversion.h>
#include <libmain.h>
#include <parseoptions.h>
#include "auth.h"
#include "mail.h"
#include "alias.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("(auth)(mail)(alias)") { }
 };

int parseoptionst::doit()
 {
  if(cmdline.isset("auth"))
    do_auth(std::cout);
  else if(cmdline.isset("mail"))
    do_mail(std::cout);
  else if(cmdline.isset("alias"))
    do_alias(std::cout);
  else
    help();

  return 0;
 }

/*******************************************************************\

Function: parseoptionst::help

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void parseoptionst::help()
 {
  std::cout <<
    "\n"
    "* * DBGEN - DBOX Database Extraction - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " dbgen [-?] [-h]              show help\n"
    " dbgen --auth                 extract authentication table\n"
    " dbgen --mail                 extract email table\n"
    " dbgen --alias                extract alias table\n"
    "\n"
    "Additonal options:\n"
    " -b boxname                   set boxname\n"
    "\n";
 }

/*******************************************************************\

Function: main

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
