/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#ifndef DBLIB_FILE_TABLE_H
#define DBLIB_FILE_TABLE_H

#include <dblib/stream_table.h>

class file_tablet:public stream_tablet
 {
 public:
  file_tablet() { }
 
  file_tablet(const std::string &__file, typet __type):
    _file(__file)
   { set_type(__type); open(); }
   
  virtual ~file_tablet() { }

  virtual bool open(const std::string &filename);
  virtual bool write(const std::string &filename);

  bool open() { return open(_file); }
  bool write() { return write(_file); }
  
 protected:
  std::string _file;
 };

#endif
