/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include "os_dep_socket.h"
#include "getpeer.h"

/*******************************************************************\

Function: getpeer

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

std::string getpeer(int handle)
 {
  #ifndef WIN32
  struct sockaddr_in sin;
  socklen_t sval;

  sval=sizeof(sin);
  if(getpeername(handle, (struct sockaddr *)&sin, &sval)<0)
    return "(unknown)";

  return inet_ntoa(sin.sin_addr);
  #else
  return "(unknown)";
  #endif
 }

