/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#ifndef DBLIB_HTTPD_H
#define DBLIB_HTTPD_H

//#include <time.h>

#include <map>
#include <string>
#include <iostream>
#include <sstream>

class httpd_baset
 {
 public:
  httpd_baset(std::istream &_in, std::ostream &_out);
  virtual ~httpd_baset();
  
  virtual void httpd();

 protected:
  std::istream &in;
  std::ostream &out;
  std::ostringstream html;

  std::string command, url, version;
  enum methodt { GET, PUT, POST, UNKNOWN } method;

  std::map<std::string, std::string> parameters;
  std::map<std::string, std::string> headers;

  virtual void process_request();
  virtual void status_response(unsigned code, const std::string &msg);
  virtual void send_html();
  virtual void error(unsigned code, const std::string &msg);

  void basic_auth(std::string &username, std::string &password);

  void send_header(const std::string &content_type,
                   unsigned long content_length);
  virtual void send_server() { out << "Server: DBOX HTTPD (Unix)\r\n"; }
  void send_connection();

  void parse_parameter(char *str);  

  void parse_command();
  void parse_command(char *c);

  void decode_url(std::string &url);

  void read_command();
  void read_header();
  void read_line(std::string &buffer);
 };

#endif
