/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include "mime_type.h"

typedef struct _ext_table_entry
 {
  char *name;
  char *mime_type;
  char *mime_encoding;
  char *icon;
 } ext_table_entry;

#include "mime_table.h"

/*******************************************************************\

Function: get_mime_type

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

const std::string get_mime_type(const std::string &filename)
 {
  int i;
  const char *extension=strrchr(filename.c_str(), '.');
  if(extension==NULL) return "";

  extension++;

  for(i=0; i<EXT_TABLE_LEN; i++)
    if(strcasecmp(extension, ext_mime_table[i].name)==0)
      return ext_mime_table[i].mime_type;

  return "";
 }
