/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#ifndef DBLIB_OS_DEP_FILE_H
#define DBLIB_OS_DEP_FILE_H

#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <fcntl.h>
#include <errno.h>

#ifdef WIN32
#include <io.h>
#endif
              
#define DIRCHAR "/"

#include <string>

std::string build_path(const std::string &path, const std::string &filename);

unsigned long filelength(const std::string &name);

#ifndef O_BINARY
#define O_BINARY 0
#endif

#endif
