/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#if 0
#include <tools.h>
#include <charsettools.h>
#include <stringtools.h>
#include <mimedecode.h>
#include <dblib/rfc1522.h>
#include <htmltools.h>
#endif

#include "rfc822.h"
#include "parse_from.h"

/*******************************************************************\

Function: parse_route_address

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void parse_route_address(const std::vector<rfc822symbolt> &symbols,
                         std::string &email, std::string &name)
 {
  bool phrase=true;

  for(unsigned i=0; i<symbols.size(); i++)
   {
    std::string text;

    if(symbols[i].type==rfc822symbolt::SPECIAL)
     {
      if(symbols[i].text==",") // list
        break;
      else if(symbols[i].text=="<")
        phrase=false;
      else if(symbols[i].text==">")
        break;
      else
        text=symbols[i].text;
     }
    else if(symbols[i].type==rfc822symbolt::COMMENT)
      text='('+symbols[i].text+')';
    else if(symbols[i].type==rfc822symbolt::DOMAIN_LITERAL)
      text='['+symbols[i].text+']';
    else if(symbols[i].type==rfc822symbolt::END_OF_LIST)
      break;
    else
      text=symbols[i].text;

    if(phrase)
     {
      if(name!="") name+=' ';
      name+=text;
     }
    else
      email+=text;
   }
 }

/*******************************************************************\

Function: parse_addr_spec

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void parse_addr_spec(const std::vector<rfc822symbolt> &symbols,
                     std::string &email, std::string &name)
 {
  for(unsigned i=0; i<symbols.size(); i++)
    if(symbols[i].type==rfc822symbolt::SPECIAL)
     {
      if(symbols[i].text==",") // list
        break;
      
      email+=symbols[i].text;
     }
    else if(symbols[i].type==rfc822symbolt::COMMENT)
      name+=symbols[i].text;
    else if(symbols[i].type==rfc822symbolt::END_OF_LIST)
      break;
    else if(symbols[i].type==rfc822symbolt::DOMAIN_LITERAL)
      email+='['+symbols[i].text+']';
    else
      email+=symbols[i].text;
 }

/*******************************************************************\

Function: parse_from

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void parse_from(const std::string from,
                std::string &email, std::string &name)
 {
  std::vector<rfc822symbolt> symbols;

  email=name="";

  parserfc822symbols(from, symbols);

  for(unsigned i=0; i<symbols.size(); i++)
    if(symbols[i].type==rfc822symbolt::SPECIAL)
     {
      if(symbols[i].text==",") // list
        break;

      if(symbols[i].text=="<") // it is a route address
       {
        parse_route_address(symbols, email, name);
        return;
       }
     }

  parse_addr_spec(symbols, email, name);
 }

