/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include "str_getline.h"

/*******************************************************************\

Function: str_getline_main

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

std::istream &str_getline_main(std::istream &in, std::string &dest,
                               bool crlf)
 {
  #define BUFSIZE 4096

  char buffer[BUFSIZE]="";
  char ch;
  unsigned i=0;

  dest.erase();

  while(in)
   {
    in.get(ch);

    if(ch=='\n')
      break;

    if(ch!='\r')
     {
      buffer[i++]=ch;
      buffer[i]=0;

      if(i==(BUFSIZE-1))
       {
        dest+=buffer;
        i=0;
        buffer[i]=0;
       }
     }
   }

  dest+=buffer;

  return in;
 }

/*******************************************************************\

Function: str_getline

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

std::istream &str_getline(std::istream &in, std::string &dest)
 {
  return str_getline_main(in, dest, false);
 }

/*******************************************************************\

Function: str_getline_crlf

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

std::istream &str_getline_crlf(std::istream &in, std::string &dest)
 {
  return str_getline_main(in, dest, true);
 }

