/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <tools.h>
#include <dboxpath.h>
#include <log_serv.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "dboxpop3.h"
#include "pop.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("") { }
 };

int parseoptionst::doit()
 {
  #ifdef DBOX_STANDALONE
  log_serv.openlog("pop3");
  #else
  log_serv.openlog("dboxpop3");
  #endif

  dopop3();

  return 0;
 }

void parseoptionst::help()
 {
  std::cerr <<
    "\n"
    #ifdef DBOX_STANDALONE
    "* * DKPOP3 - POP3 Server for DKIMAP4 - Version " DBOXVERSIONNR " * *\n"
    #else
    "* * DBOXPOP3 - DBOX module for POP3 - Version " DBOXVERSIONNR " * *\n"
    #endif
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " dboxpop3 [-?] [-h]           Print usage notes\n"
    "\n"
    "Additional options:\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
