#include        "dboxradius.h"

int
user_find(req_name, auth_name, request_pairs, check_pairs, reply_pairs, user_desc, rejecterror, pm) 
char		*req_name;
char		*auth_name;
VALUE_PAIR	*request_pairs;
VALUE_PAIR	**check_pairs;
VALUE_PAIR	**reply_pairs;
USER_DESC	*user_desc;
char            **rejecterror;
char            *pm;
{
	char		buffer[MAXBUF];
	char		*ptr;
	int		req_namelen;
	int		mode;
	int		user_auth_name();
	VALUE_PAIR	*check_first;
	VALUE_PAIR	*reply_first;
        VALUE_PAIR	*get_attribute(), *get_pair;

        /* DK */
        struct userinfot userinfo;

	/* 
	 * Check for valid input, zero length names not permitted 
	 */

	mode = FIND_MODE_NAME;

	ptr=req_name;
	while (*ptr != '\0') {
		if (*ptr == ' ' || *ptr == '\t') {
#ifdef SPACECHOP
			*ptr = '\0';
#else
                        *rejecterror="space in username";
			log_err("user_find: space in username <%s> rejected\n",req_name);
			return(-1);
#endif
		} else {
			ptr++;
		}
	}

	req_namelen=strlen(req_name);

	if (req_namelen < 1) {
		log_err("user_find: zero length username rejected\n");
		return(-1);
	}

	check_first = (VALUE_PAIR *)NULL;
	reply_first = (VALUE_PAIR *)NULL;

        strncpy(userinfo.username, req_name, 99);
        userinfo.username[99]=0;
        userinfo.pair=request_pairs;
        strncpy(auth_name, userinfo.username, AUTH_STRING_LEN);
        auth_name[AUTH_STRING_LEN]=0;

        if(!dboxuser(&userinfo, rejecterror, pm, 0))
         {
	  get_pair=get_attribute(request_pairs, 32);
          if(get_pair!=NULL)
           {
            snprintf(buffer, MAXBUF, "NAS-Identifier=\"%s\"\n", get_pair->strvalue);
            userparse(buffer, &reply_first);
           }

          snprintf(buffer, MAXBUF, "Password=\"%s\"\n", userinfo.password);
          userparse(buffer, &check_first);

          snprintf(buffer, MAXBUF, "Service-Type=%s\n", userinfo.service_type);
          userparse(buffer, &reply_first);

          if(userinfo.session_timeout[0]!=0)
           {
            snprintf(buffer, MAXBUF, "Session-Timeout=%s\n", userinfo.session_timeout);
            userparse(buffer, &reply_first);
           }

          if(userinfo.framed_protocol[0]!=0)
           {
            snprintf(buffer, MAXBUF, "Framed-Protocol=%s\n", userinfo.framed_protocol);
            userparse(buffer, &reply_first);

            snprintf(buffer, MAXBUF, "Framed-Address=255.255.255.254\n");
            userparse(buffer, &reply_first);

            snprintf(buffer, MAXBUF, "Framed-Netmask=255.255.255.255\n");
            userparse(buffer, &reply_first);

            snprintf(buffer, MAXBUF, "Framed-Routing=None\n");
            userparse(buffer, &reply_first);
           }

          snprintf(buffer, MAXBUF, "Idle-Timeout=600\n");
          userparse(buffer, &reply_first);

          if(userinfo.message[0]!=0)
           {
            snprintf(buffer, MAXBUF, "Reply-Message=\"%s\"\n", userinfo.message);
            userparse(buffer, &reply_first);
           }

          if(userinfo.framed_compression[0]!=0)
           {
            snprintf(buffer, MAXBUF, "Framed-Compression=%s\n", userinfo.framed_compression);
            userparse(buffer, &reply_first);
           }

          snprintf(buffer, MAXBUF, "Port-Limit=4\n");
          userparse(buffer, &reply_first);

          *check_pairs = check_first;
          *reply_pairs = reply_first;

          return 0;
         }

	/* Update the callers pointers */
	if(reply_first != (VALUE_PAIR *)NULL) {
		*check_pairs = check_first;
		*reply_pairs = reply_first;
		return(0);
	}
	return(-1);
}
