/*

  DBOX Module
  Copyright (C) 1994-2003 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <ctype.h>

#include <libdbox/stringtools.h>
#include <dblib/i2string.h>
#include <dblib/os_dep_file.h>

#include "extern_filename.h"

/*******************************************************************\

Function: check_reserved

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool check_reserved(const char *name)
 {
  return strcasecmp(name, "profile")==0 ||
         strcasecmp(name, "profile.tmp")==0 ||
         strcasecmp(name, "konto")==0 ||
         strcasecmp(name, "auszug")==0 ||
         strcasecmp(name, "logfile")==0 ||
         strcasecmp(name, "index")==0 ||
         strcasecmp(name, "index.tmp")==0 ||
         strcasecmp(name, "grants")==0 ||
         strcasecmp(name, "grants.tmp")==0 ||
         strcasecmp(name, "index.html")==0 ||
         strcasecmp(name, "INDEX")==0 ||
         strcasecmp(name, "header")==0 ||
         strcasecmp(name, "header.tmp")==0 ||
         strcasecmp(name, "con")==0 ||
         strcasecmp(name, "aux")==0 ||
         strcasecmp(name, "prn")==0 ||
         strcasecmp(name, "nul")==0 ||
         strcasecmp(name, "clock$")==0 ||
         strcasecmp(name, "com1")==0 ||
         strcasecmp(name, "com2")==0 ||
         strcasecmp(name, "com3")==0 ||
         strcasecmp(name, "com4")==0 ||
         strcasecmp(name, "com5")==0 ||
         strcasecmp(name, "com6")==0 ||
         strcasecmp(name, "com7")==0 ||
         strcasecmp(name, "com8")==0 ||
         strcasecmp(name, "com9")==0 ||
         strcasecmp(name, "lpt1")==0 ||
         strcasecmp(name, "lpt2")==0 ||
         strcasecmp(name, "lpt3")==0 ||
         strcasecmp(name, "lpt4")==0 ||
         strcasecmp(name, "lpt5")==0 ||
         strcasecmp(name, "lpt6")==0 ||
         strcasecmp(name, "lpt7")==0 ||
         strcasecmp(name, "lpt8")==0 ||
         strcasecmp(name, "lpt9")==0;
 }

/*******************************************************************\

Function: extern_filename

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void extern_filename(std::string &filename,
                     const std::string &hint,
                     const std::string &directory)
 {
  std::string new_filename=hint;

  if(new_filename.size()>70)
    new_filename.resize(70);

  if(new_filename.size()!=0 &&
     new_filename[0]=='-')
    new_filename[0]='_';

  if(new_filename.size()!=0 &&
     check_reserved(new_filename.c_str()))
    new_filename[0]='_';

  bool alluppercase=true;

  for(std::string::size_type i=0; i<new_filename.size(); i++)
   {
    char ch=new_filename[i];

    if(isascii(ch) &&
       (isalpha(ch) || isdigit(ch) || 
        ch=='-' || ch=='_'))
     {
      if(ch>='a' && ch<='z') alluppercase=false;
     }
    else
      new_filename[i]='_';
   }

  if(alluppercase)
   {
    for(std::string::size_type i=0; i<new_filename.size(); i++)
      new_filename[i]=dncase(new_filename[i]);
   }

  new_filename=build_path(directory, new_filename);

  filename=new_filename;

  unsigned i=1;
  while(access(filename.c_str(), 00)==0)
   {
    filename=new_filename+i2string(i);
    i++;
   }
 }
