/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <fstream>

#include <dblib/str_getline.h>
#include <dblib/os_dep_file.h>
#include <dblib/i2string.h>

#include "folder_path.h"

/*******************************************************************\

Function: folder_path

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void folder_path(const std::string &userdir,
                 const std::string &name,
                 std::string &dest)
 {
  if(name=="0") // special case for historical reasons
    dest=build_path(userdir, "mail");
  else
    dest=build_path(build_path(userdir, "mfolders"), name);
 }

/*******************************************************************\

Function: folder_name

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void folder_name(const std::string &maildir,
                 const std::string &folder_owner,
                 const std::string &mailbox_name,
                 std::string &dest)
 {
  dest="";

  if(mailbox_name=="") return;

  std::string user_path=build_path(maildir, folder_owner);
  std::string filename=build_path(user_path, "folders");

  std::ifstream in(filename.c_str());

  if(!in)
   { 
    if(mailbox_name=="INBOX")
      dest="0";

    return;
   }

  std::string line;

  for(unsigned i=0; str_getline_crlf(in, line); i++)
   {
    if(mailbox_name==line)
     { 
      dest=i2string(i);
      return;
     }
   }
 }

/*******************************************************************\

Function: folder_path

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void folder_path(const std::string &maildir,
                 const std::string &folder_owner,
                 const std::string &folder_name,
                 std::string &dest)
 {
  dest="";
  if(folder_name=="") return;

  folder_path(build_path(maildir, folder_owner), folder_name, dest);
 }
