/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose:

*/

#include <fstream.h>
#include <sysexits.h>
#include <unistd.h>

#include <dboxpath.h>
#include <logf.h>
#include <config.h>
#include <stringtools.h>
#include <tools.h>
#include <spoolp.h>
#include "deliver.h"

std::string get_from()
 {
  char line[10000], ch;
  
  if(!cin.get(line, 10000-1)) return "";

  cin.get(ch); // read newline

  if(strncmp(line, "From ", 5)!=0)
    return "";

  char *tptr=line+5;

  while(*tptr!=0 && *tptr!=' ' &&
        *tptr!='\r' && *tptr!='\n')
    tptr++;

  *tptr=0;

  return line+5;
 }

int do_deliver(cmdlinet &cmdline)
 {
  std::string envelope_from=get_from();

  std::string tmpfilename;

  getdboxtempdir(tmpfilename, config.dboxdir);
  tmpfilename+="deliver."+i2string(getpid())+"."+
               i2string((unsigned)time(NULL))+".tmp";

   {
    ofstream tmpoutfile(tmpfilename.c_str(),
      std::ios::out|std::ios::noreplace|std::ios::binary);

    if(!tmpoutfile)
     {
      cerr << "failed to create temp file \""
           << tmpfilename << "\"\n";
      return EX_TEMPFAIL;
     }

    tmpoutfile << "FROM: " << envelope_from << "\n";

    for(int i=0; i<cmdline.args.size(); i++)
      tmpoutfile << "RCPT: " << cmdline.args[i] << "\n";

    streampos msg_len_pos=tmpoutfile.tellp();
    tmpoutfile.form("LEN: %20lu\n", 0L);

    tmpoutfile << "\n";

    streampos msg_start_pos=tmpoutfile.tellp();

    if(filecopy(cin, tmpoutfile) || !tmpoutfile)
     {
      cerr << "failed to store message in temp file\n";
      unlink(tmpfilename.c_str());
      return EX_TEMPFAIL;
     }

    streampos msg_end_pos=tmpoutfile.tellp();
    streampos msg_len=msg_end_pos-msg_start_pos;

    tmpoutfile.seekp(msg_len_pos);
    tmpoutfile.form("LEN: %20lu\n", msg_len);
   }

   {
    std::string fromsystem;

     {
      char buffer[TEXTLEN];
      gethostname(buffer, TEXTLEN-1);
      fromsystem=buffer;
     }

    if(spool_erfc_mail(tmpfilename, fromsystem))
     {
      cerr << "failed to spool temp file\n";
      unlink(tmpfilename.c_str());
      return EX_TEMPFAIL;
     }
   }

  return EX_OK;
 }
