#include <string.h>
#include <stdio.h>

#include <config.h>
#include <dboxpath.h>

void mkboxdir(char *boxdir, const char *boxname)
 {
  if(boxname==NULL || boxname[0]==0)
    boxname=config.boxname;

  snprintf(boxdir, DIRLEN, DBOXBOXDIR, config.dboxdir, boxname);
 }

void getdboxtempdir(std::string &dest, const std::string &dboxdir)
 {
  dest=dboxdir+"tmp"+DIRCHAR;
 }

void getdboxportdir(std::string &dest, const std::string &dboxdir, unsigned port)
 {
  char nr[TEXTLEN];
  snprintf(nr, TEXTLEN, "%u", port);
  dest=dboxdir+"port"+DIRCHAR+nr+DIRCHAR;
 }

void getdboxporttempdir(std::string &dest, const std::string &dboxdir, unsigned port)
 {
  getdboxportdir(dest, dboxdir, port);
  dest+="tmp";
  dest+=DIRCHAR;
 }

void getdboxsystemdir(std::string &dest, const std::string &dboxdir)
 {
  dest=dboxdir+"system"+DIRCHAR;
 }

void getdboxhtmldir(std::string &dest, const std::string &dboxdir)
 {
  dest=dboxdir+"html"+DIRCHAR;
 }

void getdboxboxdir(std::string &dest, const std::string &dboxdir, const std::string &box)
 {
  dest=dboxdir+box+DIRCHAR;
 }

void getboxlockdir(std::string &dest, const std::string &boxdir)
 {
  dest=boxdir+"lock"+DIRCHAR;
 }

void getboxsystemdir(std::string &dest, const std::string &boxdir)
 {
  dest=boxdir+"system"+DIRCHAR;
 }

void getboxuserdir(std::string &dest, const std::string &boxdir, const std::string &user)
 {
  dest=boxdir+"user"+DIRCHAR+user+DIRCHAR;
 }

void getboxuserdocdir(std::string &dest, const std::string &boxdir, 
                      const std::string &user, const std::string &folder)
 {
  dest=boxdir+"user"+DIRCHAR+user+DIRCHAR+"doc"+DIRCHAR+folder+DIRCHAR;
 }

void getboxusermaildir(std::string &dest, const std::string &boxdir, 
                       const std::string &user, const std::string &folder)
 {
  dest=boxdir+"user"+DIRCHAR+user+DIRCHAR+"mfolders"+DIRCHAR+folder+DIRCHAR;
 }

void getboxhtmldir(std::string &dest, const std::string &boxdir)
 {
  dest=boxdir+"html"+DIRCHAR;
 }

void getboxlogdir(std::string &dest, const std::string &boxdir)
 {
  dest=boxdir+"log"+DIRCHAR;
 }

void getboxticketdir(std::string &dest, const std::string &boxdir)
 {
  dest=boxdir+"ticket"+DIRCHAR;
 }
