#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#ifndef WIN32
#include <unistd.h>
#else
#include <winport.h>
#endif

#include <fstream>

#include <folder.h>
#include <dboxpath.h>
#include <config.h>
#include <userdb.h>
#include <grants.h>

// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

void folderpt::setfilename()
 {
  if(name[0]=='/') // News
   {
    snprintf(path, DIRLEN, BOXBRETTERDIR "%s" DIRCHAR, 
      pconfig->boxdir, name+1);
   }
  else // Mail
   {
    char *tptr, subfolder[TEXTLEN];

    strmaxcpy(subfolder, name, TEXTLEN-1);
    tptr=strchr(subfolder, '@');

    if(tptr==(char *)NULL)
     {
      char username[TEXTLEN];
      strmaxcpy(username, name, TEXTLEN-1);
      strmaxcpy(subfolder, "0", TEXTLEN-1);
      snprintf(name, TEXTLEN, "%s@%s", subfolder, username);

      snprintf(path, DIRLEN, BOXUSERDIR "mail" DIRCHAR,
        pconfig->boxdir, username);
     }
    else
     {
      char username[TEXTLEN];

      *(tptr++)=0;
      strmaxcpy(username, tptr, TEXTLEN-1);

      if(stricmp(subfolder, "0")==0)
        snprintf(path, DIRLEN, BOXUSERDIR "mail" DIRCHAR,
          pconfig->boxdir, username);
      else
        snprintf(path, DIRLEN, BOXUSERMAILDIR,
          pconfig->boxdir, username, subfolder);
     }
   }

  strmaxcpy(locktype, "folder", TEXTLEN-1);
  snprintf(filename, DIRLEN, "%sprofile", path);
 }
 
bool folderpt::add()
 {
  return TRUE;
 }

bool folderpt::del()
 {
  return TRUE;
 }

// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

bool mailfolderalias(std::string &folder_owner, std::string &subfolder)
 {
  std::string folder_name;
  folderpt fp;

  folder_name=subfolder+"@"+folder_owner;

  fp.setname(folder_name);
  fp.read();

  std::string alias_user=(fp|"alias.user");
  std::string alias_mailbox=(fp|"alias.mailbox");
  if(alias_user=="") return FALSE;

  if(get_subfolder(alias_user, alias_mailbox, subfolder))
    return TRUE;

  folder_owner=alias_user;
  return FALSE;
 }
 
// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

bool get_subfolder(const std::string &folder_owner,
                   const std::string &mailbox_name,
                   std::string &subfolder)
 {
  subfolder="";

  if(mailbox_name=="") return TRUE;

  std::string filename;
  getboxuserdir(filename, config.boxdir, folder_owner);
  filename+="folders";
  std::ifstream in(filename.c_str());

  if(in==NULL)
   { 
    if(mailbox_name=="INBOX")
     {
      subfolder="0";
      return FALSE;
     }
    return TRUE;
   }

  char line[TEXTLEN], *tptr, ch;

  for(unsigned i=0; in.get(line, TEXTLEN-1); i++)
   {
    in.get(ch); // read \n
    tptr=strchr(line, '\n'); if(tptr!=NULL) *tptr=0;
    tptr=strchr(line, '\r'); if(tptr!=NULL) *tptr=0;
    if(mailbox_name==line)
     {
      char tempstr[TEXTLEN];
      snprintf(tempstr, TEXTLEN, "%u", i);
      subfolder=tempstr;
      return FALSE;
     }
   }

  return TRUE;
 }

// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

bool checkreserved(const char *name)
 {
  return stricmp(name, "profile")==0 ||
         stricmp(name, "profile.tmp")==0 ||
         stricmp(name, "konto")==0 ||
         stricmp(name, "auszug")==0 ||
         stricmp(name, "logfile")==0 ||
         stricmp(name, "index")==0 ||
         stricmp(name, "index.tmp")==0 ||
         stricmp(name, "grants")==0 ||
         stricmp(name, "grants.tmp")==0 ||
         stricmp(name, "index.html")==0 ||
         stricmp(name, "INDEX")==0 ||
         stricmp(name, "header")==0 ||
         stricmp(name, "header.tmp")==0 ||
         stricmp(name, "con")==0 ||
         stricmp(name, "aux")==0 ||
         stricmp(name, "prn")==0 ||
         stricmp(name, "nul")==0 ||
         stricmp(name, "clock$")==0 ||
         stricmp(name, "com1")==0 ||
         stricmp(name, "com2")==0 ||
         stricmp(name, "com3")==0 ||
         stricmp(name, "com4")==0 ||
         stricmp(name, "com5")==0 ||
         stricmp(name, "com6")==0 ||
         stricmp(name, "com7")==0 ||
         stricmp(name, "com8")==0 ||
         stricmp(name, "com9")==0 ||
         stricmp(name, "lpt1")==0 ||
         stricmp(name, "lpt2")==0 ||
         stricmp(name, "lpt3")==0 ||
         stricmp(name, "lpt4")==0 ||
         stricmp(name, "lpt5")==0 ||
         stricmp(name, "lpt6")==0 ||
         stricmp(name, "lpt7")==0 ||
         stricmp(name, "lpt8")==0 ||
         stricmp(name, "lpt9")==0;
 }

// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

bool check_reserved(const char *name)
 {
  return stricmp(name, "profile")==0 ||
         stricmp(name, "profile.tmp")==0 ||
         stricmp(name, "konto")==0 ||
         stricmp(name, "auszug")==0 ||
         stricmp(name, "logfile")==0 ||
         stricmp(name, "index")==0 ||
         stricmp(name, "index.tmp")==0 ||
         stricmp(name, "grants")==0 ||
         stricmp(name, "grants.tmp")==0 ||
         stricmp(name, "index.html")==0 ||
         stricmp(name, "INDEX")==0 ||
         stricmp(name, "header")==0 ||
         stricmp(name, "header.tmp")==0 ||
         stricmp(name, "con")==0 ||
         stricmp(name, "aux")==0 ||
         stricmp(name, "prn")==0 ||
         stricmp(name, "nul")==0 ||
         stricmp(name, "clock$")==0 ||
         stricmp(name, "com1")==0 ||
         stricmp(name, "com2")==0 ||
         stricmp(name, "com3")==0 ||
         stricmp(name, "com4")==0 ||
         stricmp(name, "com5")==0 ||
         stricmp(name, "com6")==0 ||
         stricmp(name, "com7")==0 ||
         stricmp(name, "com8")==0 ||
         stricmp(name, "com9")==0 ||
         stricmp(name, "lpt1")==0 ||
         stricmp(name, "lpt2")==0 ||
         stricmp(name, "lpt3")==0 ||
         stricmp(name, "lpt4")==0 ||
         stricmp(name, "lpt5")==0 ||
         stricmp(name, "lpt6")==0 ||
         stricmp(name, "lpt7")==0 ||
         stricmp(name, "lpt8")==0 ||
         stricmp(name, "lpt9")==0;
 }

// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

void makeexternfilename(std::string &filename,
                        const std::string &hint,
                        const std::string &directory)
 {
  char tempstr[DIRLEN], *tptr;
  char _filename[DIRLEN];
  bool alluppercase=TRUE;
  dword i;

  if(hint=="")
    strmaxcpy(tempstr, "mail", DIRLEN-1);
  else
    strmaxcpy(tempstr, hint.c_str(), DIRLEN-1);

  tempstr[70]=0;

  if(check_reserved(tempstr))
    tempstr[0]='_';

  if(tempstr[0]=='-') tempstr[0]='_';

  tptr=tempstr;
  while(*tptr!=0)
   {
    if(isascii(*tptr) &&
       (isalpha(*tptr) || isdigit(*tptr) || 
        *tptr=='-' || *tptr=='_'))
     {
      if(*tptr>='a' && *tptr<='z') alluppercase=FALSE;
     }
    else
      *tptr='_';

    tptr++;
   }

  if(alluppercase)
   {
    tptr=tempstr;
    while(*tptr!=0)
     {
      *tptr=dncase(*tptr);
      tptr++;
     }
   }

  snprintf(_filename, DIRLEN, "%s%s", directory.c_str(), tempstr);

  tptr=_filename+strlen(_filename);
  i=1;
  while(access(_filename, 00)==0)
   {
    sprintf(tptr, "_%lu", i);
    i++;
   }

  filename=_filename;
 }

// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

void folder_grantst::clear()
 {
  del=lookup=read=write=insert=create=administer=keepseen=FALSE;
 }

// **********************************************************************
// *                                                                    *
// *                                                                    *
// *                                                                    *
// **********************************************************************

void parse_folder_grants(const std::string &grants_string, folder_grantst &grants)
 {
  grants.del=check_grant(grants_string, "delete");
  grants.lookup=check_grant(grants_string, "lookup");
  grants.keepseen=check_grant(grants_string, "keepseen");
  grants.read=check_grant(grants_string, "read");
  grants.write=check_grant(grants_string, "write");
  grants.insert=check_grant(grants_string, "insert");
  grants.create=check_grant(grants_string, "create");
  grants.administer=check_grant(grants_string, "administer");
 }

void get_folder_grants(const std::string &folder_owner,
                       const std::string &subfolder,
                       userpt &who_up,
                       grouppt &who_gp,
                       folder_grantst &grants)
 {
  std::string folder_name=subfolder+"@"+folder_owner;

  grants.clear();

  folderpt fp;
  fp.setname(folder_name);

  std::string infilename;

  infilename=fp.getpath();
  infilename+="grants";

  std::ifstream infile(infilename.c_str());

  if(!infile)
   {
    if(stricmp(who_up.name, folder_owner.c_str())==0)
     {
      grants.del=grants.lookup=grants.read=
      grants.write=grants.insert=grants.create=
      grants.administer=grants.keepseen=TRUE;
     }

    return;
   }

  propertyt properties;

  properties.set("folder.name", folder_name);
  properties.set("folder.owner", folder_owner);

  parse_folder_grants(get_grants("folder", properties,
    who_up, who_gp, infilename), grants);
 }


