#ifndef DBOX_LOG_SERV_H

#define DBOX_LOG_SERV_H

#include <string>
#include <general.h>

class log_servt
 {
 public:
  int printf(const char *module, const char *format, ...);
  void setport(word p) { port=p; }

  #ifndef USE_SYSLOG
  void setlogfile(const std::string &filename) { logfilename=filename; }
  #endif

  void openlog(const std::string &program_name);
  void internalerror(const char *module, const char *error);

  void initialize()
   {
    port=0;
    logfilename="";
   }
   
  log_servt()
   {
    initialize();
   }
   
  ~log_servt();

 private:
  word port;
  
  #ifdef USE_SYSLOG
  bool syslog_opened;
  #else
  std::string logfilename;
  #endif
 };

extern log_servt log_serv; // log_serv.C

#endif
