/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include <mimedecode.h>
#include <stringtools.h>
#include <dblib/mime_decode.h>

std::string mime_decode(const mimestructt &mimestruct, const rfcmessaget &rfcm)
 {
  std::string source;

  source.assign(rfcm.data+mimestruct.offset+mimestruct.headerlen,
                mimestruct.len);

  if(stringcasecmp(mimestruct.content_transfer_encoding.value,
     "quoted-printable")==0)
   {
    return mime_qp_decode(source, FALSE);
   }
  else if(stringcasecmp(mimestruct.content_transfer_encoding.value, 
     "base64")==0)
   {
    return mime_base64_decode(source);
   }

  return source;
 }
