#include <string.h>
#include <unistd.h>

#include <log_serv.h>
#include <dboxpath.h>
#include <config.h>

void movetobad(const char *oldfilename, const char *boxdir)
 {
  const char *filename;
  char newfilename[DIRLEN];
  dword count=1;

  filename=strrchr(oldfilename, DIRCHAR[0]);
  if(filename==NULL)
    filename=oldfilename;
  else
    filename++;

  do
   {
    snprintf(newfilename, DIRLEN, 
      BOXBADDIR "%lu%s", boxdir, count, filename);
    count++;
   }
  while(access(newfilename, 00)==0);

  if(rename(oldfilename, newfilename)==0)
   {
    log_serv.printf("movetobad", "File %s saved as %s", oldfilename, newfilename);
   }
  else
   {
    remove(oldfilename);
    log_serv.printf("movetobad", "Fatal: rename(\"%s\", \"%s\"); failed!",
                    oldfilename, newfilename);
   }
 }

void movetobad(bool mail, const char *filename, const char *boxdir)
 {
  char newfilename[DIRLEN], oldfilename[DIRLEN];
  dword count=1;

  if(mail)
    snprintf(oldfilename, DIRLEN, 
      BOXSPOOLINZCMAILDIR "%s", boxdir, filename);
  else
    snprintf(oldfilename, DIRLEN,
      BOXSPOOLINZCNEWSDIR "%s", boxdir, filename);

  do
   {
    snprintf(newfilename, DIRLEN,
      BOXBADDIR "%lu%s", boxdir, count, filename);
    count++;
   }
  while(access(newfilename, 00)==0);

  if(rename(oldfilename, newfilename)==0)
   {
    log_serv.printf("movetobad", "File %s saved as %s", filename, newfilename);
   }
  else
   {
    remove(oldfilename);
    log_serv.printf("movetobad", "Fatal: rename(\"%s\", \"%s\"); failed!",
                    filename, newfilename);
   }
 }

