#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
//#include <gdbm.h>

#include <general.h>
#include <dbox.h>
#include <config.h>
#include <dboxpath.h>
#include <log_serv.h>
#include <profile.h>
#include <ticket.h>
#include <lock.h>
#include <grants.h>

void ticketpt::setfilename()
 {
  int i, len; 

  snprintf(path, DIRLEN, BOXTICKETDIR "tickets" DIRCHAR, pconfig->boxdir);

  name[50]=0;
  len=strlen(name);

  for(i=0; i<len; i++)
    sprintf(path+strlen(path), "%c" DIRCHAR, name[i]);

  strmaxcpy(locktype, "ticket", TEXTLEN-1);
  snprintf(filename, DIRLEN, "%sprofile", path);
 }
 
bool ticketpt::add()
 {
  char filename[DIRLEN];
  int i, len;

  len=strlen(name);

  snprintf(filename, DIRLEN, BOXTICKETDIR "tickets" DIRCHAR, pconfig->boxdir);

  for(i=0; i<len; i++)
   {
    if(i!=0) sprintf(filename+strlen(filename), "%c", DIRCHAR[0]);
    sprintf(filename+strlen(filename), "%c", name[i]);
    if(access(filename, 00)!=0)
     {
      if(mkdir(filename, S_IRWXU)!=0)
       {
        char errormsg[DIRLEN*2];
        sprintf(errormsg, "failed to mkdir %s", filename);
        log_serv.internalerror("ticketpt::add", errormsg);
       }
     }
   }

  return FALSE;
 }

bool ticketpt::del()
 {
  return TRUE;
 }

ticketpt::ticketpt():pt()
 {
  strmaxcpy(locktype, "ticket", TEXTLEN-1);
 }

bool ticketdispenser(char *name)
 {
  char filename[DIRLEN];
  char line[TEXTLEN];
  int handle, result;
  dword nr;

  snprintf(filename, DIRLEN, BOXTICKETDIR "ticket.dat", config.boxdir);

  if(lock("ticketdispenser", "ticket.dat", "", "ticketdispenser"))
    return TRUE;

  handle=open(filename, O_CREAT|O_RDWR|O_BINARY, S_IREAD|S_IWRITE);

  result=read(handle, line, TEXTLEN-1);
  if(result<0 || result>(TEXTLEN-1))
    line[0]=0;
  else
    line[result]=0;

  if(line[0]==0)
    nr=10;
  else
    nr=atol(line);

  lseek(handle, 0, SEEK_SET);
  snprintf(line, TEXTLEN, "%lu\n", nr+1);
  write(handle, line, strlen(line));
  close(handle);

  unlock("ticketdispenser", "ticket.dat", "");

  snprintf(name, TEXTLEN, "%lu", nr);

  return FALSE;
 }

std::string get_grants(ticketpt &ticketp,
                       userpt &who_up, grouppt &who_gp)
 {
  std::string filename=ticketp.getpath();
  filename+="grants";

  propertyt properties;

  for(unsigned i=0; i<ticketp.size(); i++)
    properties.set(std::string("ticket.")+ticketp.data[i].id,
                   ticketp.data[i].data);

  return get_grants("ticket", properties, who_up, who_gp, filename);
 }
