/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <libdbox.h>

#include "url.h"

bool parse_url(const std::string &url, std::string &protocol,
              std::string &host, std::string &port, std::string &path)
 {
  unsigned i=0;
  bool doport=FALSE;

  protocol=host=port="";
  path="/";

  for(; i<url.size(); i++)
   {
    if(url[i]==':') { i++; break; }
    protocol+=url[i];
   }

  for(; i<url.size(); i++) // skip //
    if(url[i]!='/') break;

  for(; i<url.size(); i++)
   {
    if(url[i]=='/') { i++; break; }

    if(url[i]==':')
      doport=TRUE;
    else
     {
      if(doport)
        port+=url[i];
      else
        host+=url[i];
     }
   }

  for(; i<url.size(); i++)
    path+=url[i];

  if(host=="") return TRUE;

  return FALSE;
 }
 
void make_url(std::string &url, const std::string &protocol,
              const std::string &host, const std::string &port,
              const std::string &path)
 {
  url=protocol+"://"+host;
  if(port!="")
   {
    url+=':';
    url+=port;
   }
  if(path=="" || path[0]!='/') url+='/';
  url+=path;
 }
