#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>

#include <account.h>
#include <dboxpath.h>
#include <logfile.h>
#include "../../online/userlog.h"
#include "../ostatus.h"
#include "../webtools.h"
#include "handshake.h"

const char *tarife[]=
 {
  "",
  "standard",
  "medium",
  "power",
  NULL
 };

const char *tariftxt[]=
 {
  "",
  "Standard",
  "Medium",
  "Power",
  NULL
 };

const char *tarifurl[]=
 {
  "",
  "http://www.handshake.de/handshake/angebot/standard.html",
  "http://www.handshake.de/handshake/angebot/medium.html",
  "http://www.handshake.de/handshake/angebot/power.html",
  NULL
 };

void doeinstellungen(httpt &http)
 {
  char title[TEXTLEN*2];
  const char *tarif;

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  printf("<center>\n");
  printf("<table>\n");
  printf("<tr><td colspan=2><hr>\n");

  tarif=http.getparameter("tarif");
  if(stricmp(tarif, "saarsurf")==0)
   {
    printf("<tr><td>Rufnummer:<td>0681-9506 (geeignet fr Sondertarife)\n");
    printf("<tr><td>Proxy:<td>kein Proxy\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }
  else if(stricmp(tarif, tarife[1])==0 ||
          stricmp(tarif, tarife[2])==0 ||
          stricmp(tarif, tarife[3])==0)
   {
    printf("<tr><td>Rufnummer:<td>01033-0192378 (nur im Saarland, gebhrenfrei ber Telekom)\n");
    printf("<tr><td>Proxy:<td>kein Proxy (direkte Internetverbindung)\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }

  printf("<tr><td colspan=2><hr>\n");
  printf("</table>\n");
  printf("</center>\n");

  printf("<a href=\"/handshake?action=tarif\"><p>Zurck\n");

  endpage();
 }

void doanmeldung2(httpt &http)
 {
  char title[TEXTLEN*2], hs_tarif[TEXTLEN], hs_tarif_neu[TEXTLEN];
  const char *tarif, *action2;
  byte tarifnr;  // 1 standard 2 medium 3 power
  bankpt bp(status.username);

  bp.read();

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  tarif=http.getparameter("tarif");
  if(stricmp(tarif, tarife[1])==0)
    tarifnr=1;
  else if(stricmp(tarif, tarife[2])==0)
    tarifnr=2;
  else if(stricmp(tarif, tarife[3])==0)
    tarifnr=3;
  else
    return;

  status.userprofile.get("hs.tarif", hs_tarif);
  status.userprofile.get("hs.tarif_neu", hs_tarif_neu);
  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  printf("Hinweis: %s", tariftxt[tarifnr]);
  printf("\n");

  action2=http.getparameter("action2");
  if(action2==NULL) return;

  if(stricmp(action2, "anmelden")==0)
   {
    if(atoi(hs_tarif_neu)==tarifnr)
      printf(" ist bereits angemeldet!\n");
    else
     {
      if(tarifnr!=1 &&
         (!atoi(bp|"automatisch_abbuchen") || !atoi(bp|"einzugsermaechtigung")))
        printf(" konnte nicht angemeldet werden, da uns noch keine "
               "Einzugsermchtigung vorliegt!<p>\n"
               "Bitte senden Sie uns das entsprechende Formular.\n");
      else
       {
        if(!status.userprofile.lock())
         {
          status.userprofile.set("hs.tarif_neu", tarifnr);
          status.userprofile.write();
          status.userprofile.unlock();

          printf(" ist zum nchsten Monatsersten angemeldet!\n");

          userlogprintf1(status, "handshake", "%s Tarif angemeldet", tarif);
         }
        else
          printf(": Vorgang fehlgeschlagen\n");
       } 
     }
   }
  else if(stricmp(action2, "sofortanmelden")==0)
   {
    if(atoi(hs_tarif)==tarifnr)
      printf(" ist bereits aktiv!\n");
    else
     {
      if(tarifnr!=1 &&
         (!atoi(bp|"automatisch_abbuchen") || !atoi(bp|"einzugsermaechtigung")))
        printf(" konnte nicht angemeldet werden, da uns noch keine "
               "Einzugsermchtigung vorliegt!<p>\n"
               "Bitte senden Sie uns das entsprechende Formular.\n");
      else
       {
        if(!status.userprofile.lock())
         {
          status.userprofile.set("hs.tarif_neu", ""); 
          status.userprofile.set("hs.tarif", tarifnr);

          status.userprofile.write();
          status.userprofile.unlock();

          if(tarifnr!=1)
           {
            char command[1000];
            snprintf(command, 1000, "export HOME=%s; echo \"%s\" | "
                             "~/tools/hs_beitrag -t%d "
                             "> /dev/null", 
                             config.dboxdir,
                             status.username, tarifnr);
            system(command);
           }

          printf(" ist ab sofort nutzbar!\n");

          userlogprintf1(status, "handshake", "%s Tarif sofort angemeldet", tarif);
         }
        else
          printf(": Vorgang fehlgeschlagen\n");
       }
     }
   }
  else
   {
    printf("?\n");
   }

  printf("<a href=\"/handshake?action=tarif\"><p>Zurck\n");

  endpage();
 }

#if 0
void flatrate_bed()
 {
  printf("<b>Nutzungsbedingungen:</b>\n"
         "<ul>\n"
         "<li>Das Angebot ist befristet bis zum <b>30.9.99</b>. Es \n"
         "    wird in jedem Fall der volle Monatsbetrag von 75 DM,\n"
         "    auch nach Anmeldung nach dem 1.9.99.<p>\n"
         "\n"
         "<li>Das Angebot steht nur Vereinsmitgliedern zur Verfgung,\n"
         "    die auch den Mitgliedsbeitrag vollstndig bezahlen.\n"
         "    Bei Anmeldung zur Flatrate im September ist keine \n"
         "    Rckerstattung des Mitgliedsbeitrags mglich. Wenn Sie \n"
         "    die Rckerstattung des Mitgliedsbeitrags wnschen, drfen \n"
         "    Sie sich nicht anmelden.<p>\n"
         "\n"
         "<li>Es besteht das Risiko, da wir durch regulatorische \n"
         "    Eingriffe das Angebot kurzfristig vor dem 30.9.99 \n"
         "    einstellen mssen. In diesem Fall wird die Monatspauschale \n"
         "    von 75 DM anteilig zurckerstattet. Der Mitgliedsbeitrag \n"
         "    wird jedoch nach Anmeldung generell nicht zurckerstattet.<p>\n"
         "\n"
         "<li>Die Pauschale gilt in der Zeit von 21-9 Uhr. Wenn die \n"
         "    Verbindung nach 9 Uhr bestehen bleibt, werden fr die \n"
         "    Einwahl 5.5 Pf/Min berechnet.<p>\n"
         "\n"
         "<li>Die Flatrate gilt nur bei Einwahl ber die Rufnummer \n"
         "    01804-192378, nicht ber andere Rufnummern. Auf anderen \n"
         "    werden der Rufnummer entsprechende Telefongebhren \n"
         "    berechnet. Weiterhin ist zu beachten, da der Tarif von \n"
         "    48 Pf pro Verbindung nur bei Einwahl ber die Telekom \n"
         "    gilt. Erkundigen Sie sich bei Ihrer \n"
         "    Telefongesellschaft ber die aktuellen Tarife.<p>\n"
         "\n"
         "<li>Um eine berlastung zu vermeiden, ist die Zahl der Nutzer \n"
         "    begrenzt. Die Zugnge werden in der Reihenfolge der \n"
         "    Anmeldung vergeben.<p>\n"
         "\n"
         "<li><b>Die Anmeldung kann nicht widerrufen werden</b>, bitte \n"
         "    die Bedingungen vor der Anmeldung grndlich lesen.<p>\n"
         "</ul><p>\n");
 }
#endif

void doanmeldung(httpt &http)
 {
  char title[TEXTLEN*2], hs_tarif[TEXTLEN], hs_tarif_neu[TEXTLEN];
  const char *tarif;
  byte tarifnr;  // 1 standard 2 medium 3 power
  char link[1000];

  tarif=http.getparameter("tarif");
  if(stricmp(tarif, tarife[1])==0)
    tarifnr=1;
  else if(stricmp(tarif, tarife[2])==0)
    tarifnr=2;
  else if(stricmp(tarif, tarife[3])==0)
    tarifnr=3;
  else
    return;

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  status.userprofile.get("hs.tarif", hs_tarif);
  status.userprofile.get("hs.tarif_neu", hs_tarif_neu);
  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  if(atoi(hs_tarif)>3 ||
     atoi(hs_tarif_neu)>3) return;

  printf("<table>\n"
         "<tr><th>Aktueller Tarif:</td><td>%s</td>\n",
    tariftxt[atoi(hs_tarif)]);

  if(atoi(hs_tarif)!=atoi(hs_tarif_neu))
    printf("<tr><th>Tarif ab dem nchsten Monatsersten:</td><td>%s</td>\n",
      tariftxt[atoi(hs_tarif_neu)]);

  if(tarifnr!=atoi(hs_tarif) || tarifnr!=atoi(hs_tarif_neu))
    printf("<tr><th>Neuer Tarif:</td><td>%s</td>\n",
      tariftxt[tarifnr]);

  printf("<tr><th>Aktionen:</td><td>");

  snprintf(link, 1000, "/handshake?action=tarifanmeldung2&tarif=%s", tarif);

  printf("<a href=\"/handshake?action=tarif\">a) Zurck</a><br>\n");

  if(atoi(hs_tarif)==tarifnr && atoi(hs_tarif_neu)==tarifnr)
   {
   }
  else if(atoi(hs_tarif)==tarifnr && atoi(hs_tarif_neu)!=tarifnr)
    printf("<a href=\"%s&action2=anmelden\">b) Wieder anmelden</a>", link);
  else if(atoi(hs_tarif)!=tarifnr && atoi(hs_tarif_neu)==tarifnr)
   {
    printf("<a href=\"%s&action2=sofortanmelden\">b) Sofort Anmelden</a> "
           "(der volle Monatsbetrag wird <b>sofort belastet</b>,<br><b>keine Rckerstattung</b> von Teilbetrgen!)<br>", link);
   }
  else if(atoi(hs_tarif)!=tarifnr && atoi(hs_tarif_neu)!=tarifnr)
   {
    printf("<a href=\"%s&action2=sofortanmelden\">b) Sofort Anmelden</a> "
           "(der volle Monatsbetrag wird <b>sofort belastet</b>,<br><b>keine Rckerstattung</b> von Teilbetrgen!)<br>", link);

    printf("<a href=\"%s&action2=anmelden\">c) Zum nchsten Monatsanfang anmelden</a>", link);
   }

  printf("\n");

  printf("</table>\n");

  printf("<p>Achtung: Die Grundgebhr wird auch bei \"angebrochenen\" Monaten voll berechnet.<br>"
         "Beauftragen Sie daher im Zweifelsfall den jeweiligen Tarif zum nchsten Monatsersten.<p>");

  endpage();
 }

void dotarif(httpt &http)
 {
  char title[TEXTLEN*2], hs_tarif[TEXTLEN], hs_tarif_neu[TEXTLEN];
  bool bg=FALSE;

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  printf("<table>\n"
         "<tr bgcolor=\"%s\">\n"
         "<th><font color=\"%s\">Tarif</font>\n"
         "<th><font color=\"%s\">Status</font>\n"
         "<th><font color=\"%s\">Grundgebhr<br>pro Monat\n"
         "<th><font color=\"%s\">Beschreibung</font>\n",
         config.webonline_thbgcolor,
         config.webonline_thfcolor,
         config.webonline_thfcolor,
         config.webonline_thfcolor,
         config.webonline_thfcolor);

  //
  // SaarSurf
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center>SaarSurf</td>\n");

  printf("<td align=center>\n");

  printf("<img src=\"/html/icons/ok.gif\"> aktiv</td>");

  printf("<td align=center>gratis</td>\n");

  printf("<td>Internet mit Abrechnung ber Telefonrechnung<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=saarsurf\">Einstellungen</a>\n");

  //
  // Standard / Medium / Power
  //

  for(unsigned tarifnr=1; tarifnr<=3; tarifnr++)
   {
    status.userprofile.get("hs.tarif", hs_tarif);
    status.userprofile.get("hs.tarif_neu", hs_tarif_neu);
    if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

    printf("<tr bgcolor=\"%s\">",
      bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

    bg^=1;

    printf("<td align=center><a "
           "href=\"%s\">%s</a></td>\n",
           tarifurl[tarifnr], tariftxt[tarifnr]);

    printf("<td align=center>\n");

    if(atoi(hs_tarif)==tarifnr && atoi(hs_tarif_neu)==tarifnr)
      printf("<img src=\"/html/icons/ok.gif\"> aktiv");
    else if(atoi(hs_tarif)==tarifnr && atoi(hs_tarif_neu)!=tarifnr)
      printf("gekndigt zum<br>Monatsende");     
    else if(atoi(hs_tarif)!=tarifnr && atoi(hs_tarif_neu)==tarifnr)
      printf("beantragt zum<br>nchsten Monatsanfang");
    else if(atoi(hs_tarif)!=tarifnr && atoi(hs_tarif_neu)!=tarifnr)
      printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");

    printf("<br><a href=\"/handshake?action=tarifanmeldung&tarif=%s\">An/Abmeldung</a>\n", tarife[tarifnr]);

    switch(tarifnr)
     {
     case 1: printf("<td align=center>keine</td>\n"); break;
     case 2: printf("<td align=center>2,50 &euro;</td>\n"); break;
     case 3: printf("<td align=center>5,00 &euro;</td>\n"); break;
     }

    switch(tarifnr)
     {
     case 1: printf("<td>Zeittarif, <b>1.4 Cent/Min</b> rund um die Uhr inkl. Telefongebhren zzgl. 2,0 Cent pro Einwahl<br>\n"); break;
     case 2: printf("<td>Zeittarif, <b>1.4 Cent/Min</b> rund um die Uhr inkl. Telefongebhren, keine Einwahlgebhr<br>\n"); break;
     case 3: printf("<td>Zeittarif, <b>1.0 Cent/Min</b> rund um die Uhr inkl. Telefongebhren, keine Einwahlgebhr<br>\n"); break;
     }

    printf("(gebhrenfreie Rufnummer, saarlandweit verfgbar)<br>\n");
    printf("<a href=\"/handshake?action=einstellungen&tarif=%s\">Einstellungen</a>\n", tarife[tarifnr]);
    printf("</td>\n");
   }

  //
  // Pulsaar Flatrate
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/flatrate.html\">Flatrate</a>\n");

  printf("<td align=center>\n");

  printf("-");

  printf("<td align=center>35,28 &euro;\n");

  printf("<td>Flatrate, inkl. Telefongebhren<br>\n"
         "1 Jahr Mindestlaufzeit<br>\n"
         "(gebhrenfreie Rufnummer, verfgbar im Pulsaar Netz)\n");

  //
  // Pulsaar Flatrate
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/flatrate.html\">Flatrate</a>\n");

  printf("<td align=center>\n");

  printf("-");

  printf("<td align=center>50,62 &euro;\n");

  printf("<td>Flatrate, inkl. Telefongebhren<br>\n"
         "1 Monat Mindestlaufzeit<br>\n"
         "(gebhrenfreie Rufnummer, verfgbar im Pulsaar Netz)\n");

  //
  // Ende
  //

  printf("</table>\n");

  printf("<p>");

  endpage();
 }

void doflatrate(httpt &http)
 {
  startpage("Handshake Flatrate");

  std::cout << "<center><h2><u>Handshake Flatrate</u></h2></center><p>\n\n";

  if(strncmp(status.userprofile|"telefon", "0681", 4)!=0)
   {
    std::cout << "Fehler:<p>\n"
                 "Eine Registrierung ist nur dann mglich, wenn Sie\r\n" 
                 "einen Telefonanschlu im Stadtgebiet Saarbrcken\r\n"
                 "(Vorwahl 0681) haben.\r\n";
   }
  else
   {
    std::cout << "Vielen Dank fr Ihre Registrierung.<p>\r\n" 
            "Wir werden Ihnen die Flatrate-Unterlagen per Post\r\n"
            "zusenden.\r\n";

    char logfilename[DIRLEN];
    snprintf(logfilename, DIRLEN, BOXLOGDIR "flatrate.log", config.boxdir);
    logfileprintf(logfilename, "flatrate", "%s", status.username);
   }

  endpage();
 }

void dohandshake(httpt &http)
 {
  const char *action;

  action=http.getparameter("action");
  if(action==NULL) return;

  if(stricmp(action, "tarif")==0)
    dotarif(http);
  else if(stricmp(action, "tarifanmeldung")==0)
    doanmeldung(http);
  else if(stricmp(action, "tarifanmeldung2")==0)
    doanmeldung2(http);
  else if(stricmp(action, "einstellungen")==0)
    doeinstellungen(http);
  else if(stricmp(action, "flatrate")==0)
    doflatrate(http);
  else if(stricmp(action, "test")==0)
   { startpage("Test"); std::cout << config.webonline_thbgcolor; }
 }

