/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: delete mail folder

*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>

#include <dboxpath.h>
#include <tools.h>
#include <nls.h>
#include <folder.h>

#include "webtools.h"
#include "delwebmail.h"
#include "ostatus.h"

void delwebmail(std::ostream &out, getrfct &getrfc)
 {
   {
    std::string title=nls.get("webonline.mail.title");
    title+=' ';
    title+=status.username;
    startpage(out, title);
   }

  if(getrfc.fp.lock())
   {
    std::cout << "<p>Error: Failed to lock folder!</p>";
   }
  else
   {
    bool did_something=FALSE;

    for(dword i=0; !getrfc.get_folderindex(i); i++)
     {
      if(!getrfc.fi.flags.deleted)
       {
        did_something=TRUE;
        lseek(getrfc.index, i*sizeof getrfc.fi, SEEK_SET);
        getrfc.fi.flags.deleted=TRUE;
        ::write(getrfc.index, &getrfc.fi, sizeof getrfc.fi);
       }
     }

    getrfc.fp.unlock();

    if(did_something)
     {
      char filename[DIRLEN];
      FILE *outfile;

      snprintf(filename, DIRLEN, BOXTODODIR "crunch.%s", config.boxdir,
        status.username);

      outfile=fopen(filename, "wt");
      if(outfile!=NULL) fclose(outfile);

      std::cout << "<p>Alle Nachrichten wurden zum Lschen markiert!</p>\n";
     }
    else
     {
      std::cout << "<p>Alle Nachrichten waren bereits zum Lschen markiert!</p>\n";
     }
   }

  endpage(out);
 }
